// build.hxx - rectification support
//
// Copyright (C) 2000 Bruce I Mills <B.I.Mills@cs.cf.ac.uk>
// Copyright (C) 2001-2002 Frank C Langbein <frank@langbein.org>
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.

class qmatrix {

public:

  double data[9];

  void dual (double x, double y, double z);
  void vect (double x, double y, double z);
  void diag (double x, double y, double z);
  void put (char *str1 = NULL, char *str2 = NULL);

};

qmatrix operator* (double a, qmatrix const &b);
qmatrix operator* (qmatrix const &a, qmatrix const &b);
qmatrix operator- (qmatrix const &a, qmatrix const &b);
qmatrix operator+ (qmatrix const &a, qmatrix const &b);
qmatrix transpose (qmatrix const &m);
double magsqr (qmatrix const &m);
qmatrix inverse (qmatrix const &m);

void locate (pointset *ps, point *p, pointset *r);
